import themidibus.*; //MIDI Analyzer
import javax.sound.midi.*;//MIDI Player


MidiBus myBus; // The MidiBus
Square square;
Triangle trigon;
Circle circle;
Bar bar;
Rain rain;
Shape shape;

void setup() {
  size(1920, 1080);
  frameRate(120);
  background(255);
  MidiBus.list();  // List available Midi devices
  myBus = new MidiBus(this, "IAC driver", "Real Time Sequencer");  // Create a new MidiBus using the device names to select the Midi input and output devices respectively.

  //MIDI Player - Uncomment if system default MIDI device is the MIDI input
  //  try {
  //    File midiFile = new File(dataPath("music.mid"));
  //    Sequencer sequencer = MidiSystem.getSequencer();
  //    sequencer.open();
  //    Sequence sequence = MidiSystem.getSequence(midiFile);
  //    sequencer.setSequence(sequence);
  //    sequencer.start();
  //  } catch(Exception e) {}
}

void draw() {
}

void noteOn(int channel, int pitch, int velocity) {
  coloteNote(pitch, velocity, channel);
  myBus.sendNoteOn(channel, pitch, velocity); // Send a Midi noteOn
}
//
//void noteOff(int channel, int pitch, int velocity) {
//  coloteNote(pitch, 0, channel);
//  myBus.sendNoteOff(channel, pitch, velocity); // Send a Midi nodeOff
//}

//void controllerChange(int channel, int number, int value) {
//}

void coloteNote(int pitch, int velocity, int channel) {

  float NoteX;
  float NoteC;
  float VolumeY;
  float VolumeC;

  NoteX = map(pitch, 21, 108, 0, width);
  NoteC = map(pitch, 21, 108, 0, 255);
  VolumeY = map(velocity, 0, 127, 0, height);
  VolumeC = map(velocity, 0, 127, 0, 255);

  //Background fade out
  noStroke();
  colorMode(HSB, 255);
  fill(NoteC, 200, 50, 10);
  rectMode(CORNER);
  rect(0, 0, width, height);

  //Shapes

  //Square
  if (channel == 0) {
    square = new Square (NoteX, height, NoteC, NoteX, NoteC, VolumeC, VolumeC, 255, 0);
    square.spin();
    square.display();
  }
  //Square 2
  if (channel == 1) {
    square = new Square (VolumeY, NoteX, NoteX, VolumeY, VolumeC/3, 50, NoteC, 100, 0);
    square.spin();
    square.display();
  }
  //Triangle
  if (channel == 2) {
    trigon = new Triangle (NoteX, height, NoteX, 0, 0, height, NoteC, VolumeC, VolumeC*2, 255);
    trigon.display();
  }

  //Circle
  if (channel == 4) {
    circle = new Circle (VolumeY/2, random(height), VolumeY, NoteC*2, NoteX/10, VolumeC, NoteC, VolumeC*2, 200);
    circle.display();
  }
  //Bars
  if (channel == 5) {
    bar = new Bar (NoteX, VolumeY/3, VolumeY/10, NoteC, VolumeC, VolumeC*2, 200);
    bar.display();
  }
  //Rain
  if (channel == 6) {
    rain = new Rain (random(width), random(height/2), NoteC/10, NoteC*5, random(255), random(255), random(255), 255);
    rain.display();
  }
  //Rain 2
  if (channel == 6) {
    rain = new Rain (NoteX, VolumeY, NoteC/10, NoteC*5, random(255), random(255), random(255), 255);
    rain.display();
  }
  //Shape
  if (channel == 7) {
    shape = new Shape (NoteX, VolumeY, NoteC/10, VolumeC, VolumeC, NoteC, 200, 0);
    shape.display();
  }

  //Circles (empty)
  if (channel == 8) {
    circle = new Circle (VolumeY, NoteX/2, VolumeY, NoteC*2, NoteC/10, VolumeC, NoteC, VolumeC*2, 0);
    circle = new Circle (VolumeY, NoteX/2+VolumeY, VolumeY, NoteC*2, NoteC/10, VolumeC, NoteC, VolumeC*2, 0);
    circle = new Circle (VolumeY, NoteX/2+VolumeY+NoteX, VolumeY, NoteC*2, NoteC/10, VolumeC, NoteC, VolumeC*2, 0);
    circle = new Circle (VolumeY, NoteX/2+NoteX, VolumeY, NoteC*2, NoteC/10, VolumeC, NoteC, VolumeC*2, 0);
    circle.display();
  }
  //Triangle 2
  if (channel == 9) {
    trigon = new Triangle (random(NoteX), random(VolumeY), width, height, VolumeY, NoteX, NoteC, VolumeC, VolumeC*2, 0);
    trigon.display();
  }
   //Bars2
  if (channel == 10) {
    bar = new Bar (VolumeY, NoteX, VolumeY/10, NoteC, VolumeC, VolumeC*2, 200);
    bar.display();
  }
//Shape 2
  if (channel == 11) {
    shape = new Shape (random(width), random(height), NoteC/10, VolumeC, VolumeC, NoteC, 200, 0);
    shape.display();
  }

  //Values
  //  println(pitch);
  //  println(velocity);
  //  println(frameRate);
  println("Channel: " + channel);
}

